var correoschile_cart = function() {
    var _ths = this;
    this.init =  function() {
        jQuery('body').on('click', '.shipping-calculator-button', function() {
            _ths.realizarTransformaciones();
        });
    };
    this.realizarTransformaciones = function() {
        if(jQuery('#calc_shipping_comuna_container').length === 0) {
            if (jQuery('#calc_shipping_country').is('select') === true) {
                _ths.establecerComunasAlCambiarPais();
            }
            if(jQuery('#calc_shipping_country').is('select') === true) {
                _ths.establecerComunasAlCambiarRegiones();
                jQuery('#calc_shipping_city').hide();
                jQuery('#calc_shipping_city_field').append('<div id="calc_shipping_comuna_container"><select id="calc_shipping_comuna" name="calc_shipping_comuna" style="width: 100%"></select></div>');
                jQuery('#calc_shipping_comuna').select2({ width: 'resolve', placeholder: 'Comuna' });
                var state = jQuery('#calc_shipping_state').val();
                var city = jQuery('#calc_shipping_city').val();
                if (state !== '') {
                    _ths.cargarComunas(state);
                    if (city !== ''){
                        jQuery('#calc_shipping_comuna').val(city);
                    }
                }
                _ths.establecerCiudadAlCambiarComunas();
            }
        }
    };
    this.establecerComunasAlCambiarPais = function() {
        jQuery('#calc_shipping_country').on('select2:select', function(e){ 
            var country = jQuery('#calc_shipping_country').val();
            if (country === 'CL') {
                jQuery('#calc_shipping_city').hide();
                jQuery('#calc_shipping_comuna_container').show();
                jQuery('#calc_shipping_comuna').attr('disabled','disabled');
                if (jQuery('#calc_shipping_state').is('select') === true) {
                    var state = document.getElementById('calc_shipping_state');
                    var stateEvents = jQuery._data(state, 'events');
                    if (stateEvents && stateEvents.change.length < 2) {
                        _ths.establecerComunasAlCambiarRegiones();
                    }
                }
            } else {
                jQuery('#calc_shipping_comuna_container').hide();
                jQuery('#calc_shipping_city').show();
            }
        });
    };
    this.establecerComunasAlCambiarRegiones = function() {
        jQuery('#calc_shipping_state').on('select2:select', function() {
            jQuery('#calc_shipping_comuna').attr('disabled','disabled');
            _ths.cargarComunas(jQuery('#calc_shipping_state').val());
        });
    };
    this.establecerCiudadAlCambiarComunas = function(){
        jQuery('#calc_shipping_comuna').on('select2:select', function() {
            jQuery('#calc_shipping_city').val(jQuery('#calc_shipping_comuna').val());
        });
    };
    this.cargarComunas = function(region) {
        if(!region || region === '') {
            return;
        }
        jQuery('#calc_shipping_comuna').empty();
        jQuery('#calc_shipping_comuna').append('<option value=""></option>');
        jQuery('.cart_totals').block({ message: null, overlayCSS: { backgroundColor: '#fff', opacity: 0.6, cursor: 'wait' } });
        jQuery(correoschile_comunas).each(function(i, c) {
            if(c.idRegion === region){
                jQuery('#calc_shipping_comuna').append('<option value="' + String(c.nombre).trim() + '">' + String(c.nombre).trim() + '</option>');
            }
        });
        jQuery('.cart_totals').unblock();
        jQuery('#calc_shipping_comuna').removeAttr('disabled');
    };
    this.isNullOrEmpty = function (str) {
        var type = typeof (str);
        if (type === 'undefined')
            return true;
        if (type === 'object' && str === null)
            return true;
        if (type === 'string' && String(str).valueOf() === '')
            return true;
        return false;
    };
    jQuery(document.body).on('updated_cart_totals', function() {
        _ths.init();
    });
    
    _ths.init();
};