<?php

class utilidades 
{
    public static function LimpiarCaracteres($cadena)
    {
        $cadena = utilidades::QuitarAcentos($cadena);
        $cadena = str_replace(array('Ñ', 'ñ', 'Ç', 'ç', '#'),
                              array('N', 'n', 'C', 'c', ' '),
                              $cadena);
        return trim($cadena);
    }

    public static function QuitarAcentos($cadena)
    {
        $cadena = str_replace(array('Á', 'À', 'Â', 'Ä', 'á', 'à', 'ä', 'â', 'ª'),
		                      array('A', 'A', 'A', 'A', 'a', 'a', 'a', 'a', 'a'),
		                      $cadena);
        $cadena = str_replace(array('É', 'È', 'Ê', 'Ë', 'é', 'è', 'ë', 'ê'),
		                      array('E', 'E', 'E', 'E', 'e', 'e', 'e', 'e'),
		                      $cadena);
        $cadena = str_replace(array('Í', 'Ì', 'Ï', 'Î', 'í', 'ì', 'ï', 'î'),
                              array('I', 'I', 'I', 'I', 'i', 'i', 'i', 'i'),
                              $cadena);
        $cadena = str_replace(array('Ó', 'Ò', 'Ö', 'Ô', 'ó', 'ò', 'ö', 'ô'),
                              array('O', 'O', 'O', 'O', 'o', 'o', 'o', 'o'),
                              $cadena );
        $cadena = str_replace(array('Ú', 'Ù', 'Û', 'Ü', 'ú', 'ù', 'ü', 'û', "'"),
                              array('U', 'U', 'U', 'U', 'u', 'u', 'u', 'u', ''),
                              $cadena);
        return trim($cadena);
    }

    public static function SoloNumeros($cadena)
    {
        $caracteres = str_split($cadena);
        $nuevaCadena = '';
        foreach ($caracteres as $caracter) {
            if(is_numeric($caracter)) {
                $nuevaCadena .= $caracter;
            }
        }
        return $nuevaCadena;
    }

    public static function FormatearFecha($fecha) {
        $fecha = explode('-', $fecha);
        return $fecha[2] . '-' . $fecha[1] . '-' . $fecha[0];
    }

    public static function IsNullOrEmptyString($str){
        return (!isset($str) || trim($str) === '');
    }
}